//---------------------------------------------------------------------------


#pragma hdrstop

#include "lang.h"
#include "winutil.h"
#include <string>
#include <vector>

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
// Language Functions:
//---------------------------------------------------------------------------

AnsiString English[] = {"English","Inactive", "Active", "Exit", "About","Options", "OK",
                        "Hotkey", "Cancel", "Start mode", "Last setting",
                        "Remove my settings from registry",
                        "Do you wish to remove all your settings from the registry?",
                        "Hotkey function","Copy only on hotkey",
                        "Toggle active/inactive",
                        "Remove leading and trailing whitespaces",
                        "Remove leading and trailing linebreaks",
                        "Always start with Windows",
                        "Copy only links",
                        "For online-help check the following website",
                        "Language", "Auto"
};


AnsiString Danish[] = {"Dansk","Inaktiv", "Aktiv", "Afslut", "Om HovText", "Indstillinger","OK",
                        "Genvejstast", "Annuller", "Start tilstand", "Sidste tilstand",
                        "Fjern mine indstillinger fra registreringsdatabasen",
                        "Vil du fjerne alle dine indstillinger fra registeringsdatabasen?",
                        "Genvejstast funktion"," Kopier kun ved genvejstast",
                        "Skift mellem aktiv/inaktiv",
                        "Fjern mellemrum i start og slutning af teksten",
                        "Fjern linjeskift i start og slutning af teksten",
                        "Start automatisk sammen med Windows",
                        "Kopir kun links",
                        "For online-hjlp se nedenstende hjemmeside",
                        "Sprog", "Auto"
                        };


AnsiString German[] = {"Deutsch", "Inaktiv","Aktiv", "Exit","ber","Wahl","OK",
                       "Schnelltaste","Abbrechen", "Startmodus","Vorige Einstellung",
                       "Meine Einstellungen von Datenbank lschen",
                       "Alle meine Einstellungen von Datenbank lschen? ",
                       "Schnelltasten-Funktion","Nur ber Schnelltaste kopieren",
                       "Schalten zwischen aktiv/inaktiv",
                       "Leerfelder vor und nach Text entfernen ",
                       "Zeilenumbruch vor und nach Text entfernen",
                       "Automatisch zusammen mit Windows starten",
                       "Nur Links kopieren",
                       "Fr Online-Hilfe sehen Sie bitte diese Website",
                       "Sprache", "Sprache Autowahl"};



AnsiString Dutch[] = { "Nederlands", "Niet actief","Actief","Afsluiten","Over", "Opties","OK",
                       "Hotkey","Afbreken","Opstartmode","Laatste instelling",
                       "Verwijder mijn instellingen uit register",
                       "Wilt u al uw instellingen verwijderen uit het register?",
                       "Hotkey functie","Kopieer alleen naar hotkey",
                       "Toggle actief/niet actief",
                       "Verwijder de spaties voor en na de tekst",
                       "Verwijder de witregels voor en na de tekst",
                       "Altijd starten met Windows",
                       "Copieer alleen links",
                       "Voor on-line help ga naar de volgende site",
                       "Kies een taal", "Auto"};


AnsiString French[] = { "Franais", "Dsactiv", "Activ", "Quitter", "A propos","Options", "OK", "Raccourci clavier", "Annuler",
                        "Mode au dmarrage", "Dernier paramtre", "Enlever mes paramtres du registre",
                        "Voulez-vous retirez tous vos paramtres du registre ?",
                        "Fonction du raccourci","Copier uniquement sur utilisation","Activer/Dsactiver",
                        "Retirer les blancs en tte et en queue",
                        "Retirer les sauts de lignes en tte et en queue",
                        "Toujours lancer au dmarrage de Windows",
                        "Copier uniquement les liens",

                        "Pour l'aide en ligne allez  l'adresse suivante",
                        "Langage", "Auto"
                        };

AnsiString LangText(TextEnum t)
{
  if (GetRegInt("Language")<=0)
  {
	switch(PRIMARYLANGID(GetUserDefaultLCID()))
	{
	  case LANG_DANISH:  return Danish[t];
	  case LANG_GERMAN:  return German[t];
	  case LANG_DUTCH:   return German[t];
	  case LANG_FRENCH:  return French[t];
	  default:           return English[t];
	}
  } else {
	switch(GetRegInt("Language"))
	{
	  case 2:  return Danish[t];
	  case 3:  return German[t];
	  case 4:  return Dutch[t];
	  case 5:  return French[t];
	  default: return English[t];
	}
  }
}

const std::vector<AnsiString>& LangList()
{
  static std::vector<AnsiString> langlist;

  langlist.clear();
  langlist.push_back(English[TE_LangName]);
  langlist.push_back(Danish[TE_LangName]);
  langlist.push_back(German[TE_LangName]);
  langlist.push_back(Dutch[TE_LangName]);
  langlist.push_back(French[TE_LangName]);
  return langlist;

}

TLangNotifier LangNotifier;


void TLangNotifier::AddLangNotify(TLangChangeNotify *n)
{
  Clients.push_back(n);
}

void TLangNotifier::RemoveLangNotify(TLangChangeNotify *n)
{
}

void TLangNotifier::LangChange()
{
  for (std::vector <TLangChangeNotify *> ::iterator i =Clients.begin();
       i !=Clients.end(); i++)
     (*i)->LangChange();
}

